import { ElementRef, Renderer2, EventEmitter, OnChanges, SimpleChanges, NgZone } from "@angular/core";
import { AbstractControl, ValidationErrors } from "@angular/forms";
import { ICustomValueAccessorHost, CustomValueAccessor, ICustomValidatorHost, CustomValidator, PositioningPlacement, SuiComponentFactory } from "../../../misc/util/internal";
import { IDatepickerLocaleValues, RecursivePartial, SuiLocalizationService } from "../../../behaviors/localization/internal";
import { SuiPopupComponentController, PopupAfterOpen } from "../../popup/internal";
import { SuiDatepickerNext, DatepickerMode } from "../components/datepicker";
import { CalendarConfig } from "../classes/calendar-config";
export declare class SuiDatepickerNextDirective extends SuiPopupComponentController<SuiDatepickerNext> implements ICustomValueAccessorHost<Date>, ICustomValidatorHost, OnChanges, PopupAfterOpen {
    localizationService: SuiLocalizationService;
    private _selectedDate?;
    get selectedDate(): Date | undefined;
    private _mode;
    config: CalendarConfig;
    get mode(): DatepickerMode;
    set mode(mode: DatepickerMode);
    initialDate?: Date;
    maxDate?: Date;
    minDate?: Date;
    onlyEmitManual?: boolean;
    firstDayOfWeek?: number;
    forceChangeDateOverflow?: boolean;
    private _localeValues;
    localeOverrides: RecursivePartial<IDatepickerLocaleValues>;
    get localeValues(): IDatepickerLocaleValues;
    set placement(placement: PositioningPlacement);
    set transition(transition: string);
    set transitionDuration(duration: number);
    onSelectedDateChange: EventEmitter<Date>;
    onDateChange: EventEmitter<{
        value: Date | undefined;
        force: boolean;
    }>;
    onValidatorChange: EventEmitter<void>;
    constructor(renderer: Renderer2, element: ElementRef, componentFactory: SuiComponentFactory, localizationService: SuiLocalizationService, zone: NgZone);
    popupOnOpen(): void;
    ngOnChanges({ maxDate, minDate, mode }: SimpleChanges): void;
    private onLocaleUpdate;
    validate(c: AbstractControl): ValidationErrors | null;
    isValidDate(value: Date | undefined): boolean;
    private getValidValue;
    setSelectedDate(val: Date | undefined, emitValue?: boolean): void;
    writeValue(val: Date | undefined): void;
    onKeyDown(e: KeyboardEvent): void;
}
export declare class SuiDatepickerNextDirectiveValueAccessor extends CustomValueAccessor<Date, SuiDatepickerNextDirective> {
    host: SuiDatepickerNextDirective;
    constructor(host: SuiDatepickerNextDirective);
}
export declare class SuiDatepickerNextDirectiveValidator extends CustomValidator<SuiDatepickerNextDirective> {
    host: SuiDatepickerNextDirective;
    constructor(host: SuiDatepickerNextDirective);
}
//# sourceMappingURL=datepicker.directive.d.ts.map