import { ElementRef, Renderer2, OnInit } from "@angular/core";
import { SuiLocalizationService } from "../../../behaviors/localization/internal";
import { SuiDatepickerNextDirective, SuiDatepickerNextDirectiveValueAccessor } from "./datepicker.directive";
import { DateParser } from "../classes/date-parser";
import { MaskedTextChangedListener, Notation, AffinityCalculation } from "ts-input-mask";
import "../helpers/is-webview";
export declare class InputMaskOptions {
    readonly affineFormats: ReadonlyArray<string>;
    readonly customNotations: ReadonlyArray<Notation>;
    readonly affinityCalculationStrategy: AffinityCalculation;
    readonly autocomplete: boolean;
    constructor(affineFormats?: ReadonlyArray<string>, customNotations?: ReadonlyArray<Notation>, affinityCalculationStrategy?: AffinityCalculation, autocomplete?: boolean);
}
export declare class SuiDatepickerNextInputDirective implements OnInit, MaskedTextChangedListener.ValueListener {
    datepicker: SuiDatepickerNextDirective;
    valueAccessor: SuiDatepickerNextDirectiveValueAccessor;
    private _renderer;
    private _element;
    private _useNativeOnMobile;
    readonly: string;
    get useNativeOnMobile(): boolean;
    set useNativeOnMobile(fallback: boolean);
    private _fallbackActive;
    get fallbackActive(): boolean;
    set fallbackActive(active: boolean);
    get parser(): DateParser;
    private _currentInputValue;
    private _lastUpdateTyped;
    get selectedDateString(): string | undefined;
    get type(): string;
    get max(): string | undefined;
    get min(): string | undefined;
    private _maskOptions;
    set maskOptions(value: InputMaskOptions);
    constructor(datepicker: SuiDatepickerNextDirective, valueAccessor: SuiDatepickerNextDirectiveValueAccessor, _renderer: Renderer2, _element: ElementRef, localizationService: SuiLocalizationService);
    ngOnInit(): void;
    onTextChanged(maskFilled: boolean, extractedValue: string, formattedText: string): void;
    private setupListener;
    private updateValue;
    onFocusOut(): void;
}
//# sourceMappingURL=input.directive.d.ts.map